﻿//   GDM-8000 Series GP-IB Sample Program for VC# 2008 or Higher

//   Please Open project (.csproj), Not Open Solution
//   Remove Rerences for NationalInstrument common and NI488.2
//   Add References NationalInstrument common and NI488.2 on Your PC

//   ソリューションファイルでなくプロジェクトファイル(.csproj)を開いてください。
//   ナショナルインスツルメンツのライブラリの参照がおかしい場合は参照をやり直してください。


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using NationalInstruments.NI4882;

namespace PSW_Access
{
    public partial class PSW_Access : Form
    {
        private Device device;
        private int Opened;

        // Open Window
        public PSW_Access()
        {
            InitializeComponent();

            Opened = 0;
            for (int i = 1; i < 30; i++)
                cmbAddress.Items.Add(i);
            cmbAddress.SelectedIndex = 0;

            // Set form
            btnOpen_Close.Text = "OPEN";
            btnAUTO.Enabled = false;
            btnMonitor.Enabled = false;
            btnDCV.Enabled = false;
            btnACV.Enabled = false;
            btnFREQ.Enabled = false;
            cmbAddress.Enabled = true;
        }

        // Form Close(x Button)
        private void Form1_FormClosing(object sender,FormClosingEventArgs e)
        {
            // Device Close
            if(cmbAddress.Enabled == false)
                device.Write("CONF:AUTO OFF\n");

            if( Opened != 0)
                device.Dispose();

        }
        // Open/Close Button
        private void btnOpen_Close_Click(object sender, EventArgs e)
        {
            if(btnOpen_Close.Text == "OPEN"){
                try
                {
                    int BourdId = 0 ;
                    Opened = 1;
                    Cursor.Current = Cursors.WaitCursor;
                    // Device Open and Init
                    device = new Device(BourdId, (byte)(cmbAddress.SelectedIndex + 1));
                    device.Write("CONF:AUTO OFF\n");
                    btnAUTO.Text = "AUTO ON";

                    // Set form
                    btnOpen_Close.Text = "CLOSE";
                    btnAUTO.Enabled = true;

                    btnMonitor.Enabled = true;
                    btnDCV.Enabled = true;
                    btnACV.Enabled = true;
                    btnFREQ.Enabled = true;
                    cmbAddress.Enabled = false;

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
                finally
                {
                    Cursor.Current = Cursors.Default;
                }
            }
            else{
                try
                {
                    // Device Close
                    device.Write("CONF:AUTO OFF\n");
                    device.Dispose();

                    // Set form
                    btnOpen_Close.Text = "OPEN";
                    btnAUTO.Enabled = false ;

                    btnMonitor.Enabled = false ;
                    btnDCV.Enabled = false;
                    btnACV.Enabled = false;
                    btnFREQ.Enabled = false;

                    cmbAddress.Enabled = true;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }

        }

        // Monitor Button
        private void btnMonitor_Click(object sender, EventArgs e)
        {

            try
            {
                Cursor.Current = Cursors.WaitCursor;
                device.Write("READ?\n");
                txtMeasure.Text = device.ReadString() + "\r\n";
 
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
        }

        // AUTO Range Button
        private void btnAUTO_Click(object sender, EventArgs e)
        {
            if (btnAUTO.Text == "AUTO ON")
            {
                // OFF -> ON
                device.Write("Conf:AUTO ON\n");
                btnAUTO.Text = "AUTO OFF";
            }
            else
            {
                // ON -> OFF
                device.Write("CONF:AUTO OFF\n");
                btnAUTO.Text = "AUTO ON";
            }
        }

        // DCV Button
        private void btnDCV_Click(object sender, EventArgs e)
        {
            device.Write("CONF:VOLT:DC\n");
        }

        // ACV Button
        private void btnACV_Click(object sender, EventArgs e)
        {
            device.Write("CONF:VOLT:AC\n");
        }

        // FREQ Button
        private void btnFREQ_Click(object sender, EventArgs e)
        {
            device.Write("CONF:FREQ\n");
        }


        private string ReplaceCommonEscapeSequences(string s)
        {
            return s.Replace("\\n", "\n").Replace("\\r", "\r");
        }

        private string InsertCommonEscapeSequences(string s)
        {
            return s.Replace("\n", "\\n").Replace("\r", "\\r");
        }

    }
}
